<template>
    <div class="content-grid">

        <!--<Card>
            <h1>{{t('global.reintialisersiteweb')}}</h1>-->
            <!--<BtnLink :name="eretefsd"
            :path="{ name: 'admin.children.reintialiser' }" />-->
            <!--<formreintialiser @formSubmit="handleSubmit" />
        </Card>-->

        <div class="content-grid__header">
            <h1 class="back-link-title">{{ t(`global.lstmembrereintialiser`) }}</h1>
            <div class="content-grid__filters">
                <SearchInput v-model="searchValue" />
    </div>
        </div>

        <Card>
            <DataTableSansAction :headers="regleHeader"
                                 :search-value="searchValue"
                                 :is-loading="enChargement"
                                 :items="tableMembres"
                                 @ouvrir-modal-form-select-numero-lot="ouvrirmodalForm" />
        </Card>
        <modalFormPlanNumeroPlan :nolabel="nolabel" :nom-selectionne="nomselectionne" :options="tableNumeroDeLot" :isVisible="showModal" @update:isVisible="fermerForm" @formSubmit="handleSubmitNumeroPlan" />

    </div>
</template>

<script lang="ts" setup>
    import i18n from "@/i18n";
    import { useI18n } from "vue3-i18n";
    import { computed, onMounted, ref } from "vue";
    import { notifyError, notifySuccess } from "@/notify";
    import SearchInput from "@/components/layout/SearchInput.vue";
    import { FormOption } from "@/types/formOption";

    import modalFormPlanNumeroPlan from "@/components/reintialiser/modalFormNumeroPlan.vue"

    import DataTableSansAction from "@/components/layout/DataTableSansAction.vue";
    import Card from "@/components/layout/Card.vue";
    import { useMemberService,useLotService } from "../../inversify.config";
    import { Member } from "../../types";

    const { t } = useI18n()
    const memberService = useMemberService()
    const lotService=useLotService()
    const searchValue = ref("");
    const lesMembres = ref<Member[]>([]);
    const nolabel = ref(false)
    const enChargement = ref(false);
    const showModal = ref(false);
    const nomselectionne = ref<string>()
    const idMembreSelectionne = ref<string>()
    const lesNumeroDeLot = ref<FormOption[]>([])

    const tableNumeroDeLot = computed(() => {
        return lesNumeroDeLot.value.map((x: FormOption) => {
            return {
                label: x.label,
                name: x.name
            }
        })
    })

    const tt = ref<FormOption[]>([{ name: "1", label: "lot1" }, { name: "2", label: "lot2" }])


    const tableMembres = computed(() => {
        return lesMembres.value.map((x: any) => {
            return {
                id: x.id,
                prenom: (x.firstName) ?? '',
                nom: (x.lastName),
                email: (x.email),
                telephone: (x.phoneExtension) ? `${x.phoneNumber.number} (${x.phoneExtension})` : x.phoneNumber.number,
                NombreDeLot: x.lots ? x.lots.length : 0,
                DernierLot: x.lots && x.lots.length>0 ? x.lots[x.lots.length - 1].lotNumber : 0,
            }
        }).sort((a: any, b: any) => {
            if (a.prenom < b.prenom) {
                return -1;
            }
            if (a.prenom > b.prenom) {
                return 1;
            }
            return 0;
        }) as Member[];
    })


    onMounted(async () => {
        await chargerMembre();
        await chargerNumeroLot();

    });

    async function chargerNumeroLot() {
        let lotdisponible = await lotService.getLotsEmptyCurrentYear()

        if (lotdisponible && lotdisponible.length > 0) {
            lotdisponible.forEach(x => { lesNumeroDeLot.value.push({ name: x.lotNumber!.toString(), label: `Lot ${x.lotNumber}` }) })
        }

    }

    async function chargerMembre() {
        enChargement.value = true
        let membre = await memberService.getAllMembersWithUser()

        if (membre && membre.length > 0) {
            lesMembres.value = membre;
        }
        enChargement.value = false
    }


    const regleHeader = [
        {
            text: "prenom",
            value: "prenom",
            sortable: true,
            width: 150,
        },
        {
            text: "nom",
            value: "nom",
            sortable: true,
            width: 150,
        },
        {
            text: "email",
            value: "email",
            sortable: true,
            width: 150,
        },
        {
            text: "telephone",
            value: "telephone",
            sortable: true,
            width: 150,
        },
        {
            text: "Nbre de lot",
            value: "NombreDeLot",
            sortable: true,
            width: 150,
        },
        {
            text: "Dernier lot",
            value: "DernierLot",
            sortable: true,
            width: 150,
        },
    ];

    function ouvrirmodalForm(membreSelectionne: any) {
        // console.log(membreSelectionne)
        idMembreSelectionne.value = membreSelectionne.id
        nomselectionne.value = `${membreSelectionne.prenom} ${membreSelectionne.nom}`
        showModal.value = true;
    }

    function fermerForm($event: boolean) {
        showModal.value = $event
        nomselectionne.value = undefined
        idMembreSelectionne.value = undefined
    }

    async function handleSubmitNumeroPlan(numero: string) {

        const numeroLot = Number(numero)

        if (isNaN(numeroLot))
            return
        let reponse = await memberService.activerMemberDebutDanne(idMembreSelectionne.value!, numeroLot)

        if (reponse.succeeded) {
            lesNumeroDeLot.value = lesNumeroDeLot.value.filter(x => x.name !== numeroLot.toString())
            lesMembres.value = lesMembres.value.filter(x => x.id !== idMembreSelectionne.value)
            notifySuccess(t('validation.userlot.success'))
        } else {
            let errorMessages = reponse.getErrorMessages('validation.userlot',
                'validation.regle.delete.errorOccured')
            notifyError(errorMessages[0])
    }
        fermerForm(false)

    }
</script>
